class IcalController < ApplicationController
  include Icalendar

  def tv
    urls = ["http://tv.livedoor.com/rss/search?genre_code=G1&genre_code=G2&genre_code=G3&genre_code=G0&pref_id=13","http://tv.livedoor.com/rss/search?genre_code=BB&pref_id=13"]
    cal = Calendar.new
    cal.custom_property 'X-WR-CALNAME', "お気に入りの番組"
    urls.each do |url|
      feed = FeedTools::Feed.open(url)
      feed.time_to_live = 6.hour
      feed.items.each do |item|
        event = Event.new
        event.summary = "%s %s" % [item.title, item.find_node("dc:subject").text]
        event.url = item.link
        event.dtstart = DateTime.parse(item.find_node("tv:feed/tv:startDatetime/text()").to_s)
         item.find_node("tv:feed/tv:startDatetime").text
        event.dtend = DateTime.parse(item.find_node("tv:feed/tv:endDatetime/text()").to_s)
        cal.add_event(event)
      end
    end
    render :text => cal.to_ical, :layout => false
  end


  def blog
    urls = ["http://blog.masuidrive.jp/xml/rss20/feed.xml"]

    cal = Calendar.new
    cal.custom_property 'X-WR-CALNAME', "ブログ"
    urls.each do |url|
      feed = FeedTools::Feed.open(url)
      feed.time_to_live = 6.hour
      feed.items.each do |item|
        event = Event.new
        event.summary = "%s - %s" % [item.title, feed.title]
        event.url = item.link
        event.dtstart = DateTime.parse(item.published.to_s)
        event.dtend = DateTime.parse((item.published+1.hour).to_s)
        cal.add_event(event)
      end
    end
    render :text => cal.to_ical, :layout => false
  end
end
