=begin
各種設定ファイル

稼働時には必ず、Google Application IDとAmazon Access Key IDを設定してください
=end

require File.join(File.dirname(__FILE__), 'boot')

Rails::Initializer.run do |config|
  config.action_controller.session_store = :active_record_store
end

# 日付のフォーマット
ActiveSupport::CoreExtensions::Time::Conversions::DATE_FORMATS.update :default => "%Y/%m/%d %H:%M:%S"

# 必要なライブラリの読み込み インストール方法は下記の一行
# gem install json feedtools icalendar amazon-ecs --include-dependencies
require_gem "feedtools"
require_gem 'icalendar'
require_gem 'json'
require 'amazon/ecs'
require 'open-uri'
require 'date'

# FeedToolsのキャッシュ設定
FeedTools.configurations[:feed_cache] = FeedTools::DatabaseFeedCache
FeedTools.configurations[:tidy_enabled] = false

# Google APIの設定
case RAILS_ENV
when "development"
  GOOGLE_APPLICATION_ID = "開発時のGoogle Application ID"
when "production"
  GOOGLE_APPLICATION_ID = "実稼働時のGoogle Applcation ID"
end

# Amazon APIの設定
AMAZON_ACCESS_KEY_ID = "Amazon Access Key ID"
Amazon::Ecs::SERVICE_URLS[:jp] =  'http://webservices.amazon.co.jp/onca/xml?Service=AWSECommerceService'
Amazon::Ecs.options = {:aWS_access_key_id =>AMAZON_ACCESS_KEY_ID, :country => :jp}
